--¼־
create table tb_manager_log (
   id                   int                  identity,					--ID
   user_id              int                  null,						--ûID
   user_name            nvarchar(100)        null,						--û
   action_type          nvarchar(100)        null,						--
   note                 nvarchar(255)        null,						--־
   login_ip             nvarchar(30)         null,						--¼IP
   login_time           datetime             null default getdate(),    --¼ʱ
   constraint PK_TB_MANAGER_LOG primary key (id)
)
go

declare @CurrentUser sysname
select @CurrentUser = user_name()
execute sp_addextendedproperty 'MS_Description', 
   'ID',
   'user', @CurrentUser, 'table', 'tb_manager_log', 'column', 'id'
go
declare @CurrentUser sysname
select @CurrentUser = user_name()
execute sp_addextendedproperty 'MS_Description', 
   'ûID',
   'user', @CurrentUser, 'table', 'tb_manager_log', 'column', 'user_id'
go
declare @CurrentUser sysname
select @CurrentUser = user_name()
execute sp_addextendedproperty 'MS_Description', 
   'û',
   'user', @CurrentUser, 'table', 'tb_manager_log', 'column', 'user_name'
go
declare @CurrentUser sysname
select @CurrentUser = user_name()
execute sp_addextendedproperty 'MS_Description', 
   '',
   'user', @CurrentUser, 'table', 'tb_manager_log', 'column', 'action_type'
go
declare @CurrentUser sysname
select @CurrentUser = user_name()
execute sp_addextendedproperty 'MS_Description', 
   '־',
   'user', @CurrentUser, 'table', 'tb_manager_log', 'column', 'note'
go
declare @CurrentUser sysname
select @CurrentUser = user_name()
execute sp_addextendedproperty 'MS_Description', 
   '¼IP',
   'user', @CurrentUser, 'table', 'tb_manager_log', 'column', 'login_ip'
go
declare @CurrentUser sysname
select @CurrentUser = user_name()
execute sp_addextendedproperty 'MS_Description', 
   '¼ʱ',
   'user', @CurrentUser, 'table', 'tb_manager_log', 'column', 'login_time'
go